--how far from each other each skyskraper is in the skyscraper surface, in x dimension
function getSpacingX()
    return 64
end

--how far each floor is apart from each other in the skyscraper surface, in y dimension
function getSpacingY()
    return 32
end
--X+Y: size of skyscraper in tiles in both surfaces
--Z: how many floors the skyscraper has
--entrancePos: entrance position relative to entity position 
--exitPos: position of the door in the skyscraper surface, relative to the lower left corner
--stairsUpPos: where the stairs going up are located
--stairsDownPos: where the stairs going down are located
--floorIndicatorPos: position of the entity that indicates the current floor. a constant combinator is created at y+1 and another digit display at x-1 too.
--elevatorPos: position where the tile is that allows entering the elevator. on y-1 a elevator indicater is placed, and at y-2 a combinator for it
--tile: what tiles to place on the ground    
function getSkyscraperDefinitions()
    local skyscrapers = {}
    skyscrapers["skyscraper-1-crafting"] =       { unique=false, itemCategory="skyscrapers-buildings-mk1", X=10,Y=8, Z=5,  entrancePos={x=0.5,y=4}, exitPos={x=5.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=7,y=7},  stairsDownPos={x=2,y=7},  floorIndicatorPos={x=1,y=8},
        elevator=false, lampPos={x=5,y=10}, accumulatorPos={x=7,y=9}, energyBuffer="10MJ", energyFlow="2MW", tileCraft="stone-brick", tile="stone-path", 
        allowedCraftingCategories={"crafting", "advanced-crafting", "crafting-with-fluid"}, restrictionItemName="assembling-machine-1", beacon=false, techToUnlock="Skyscrapers_mk1"}
    skyscrapers["skyscraper-1-smelting"] =       { unique=false, itemCategory="skyscrapers-buildings-mk1", X=10,Y=8, Z=5,  entrancePos={x=0.5,y=4}, exitPos={x=5.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=7,y=7},  stairsDownPos={x=2,y=7},  floorIndicatorPos={x=1,y=8},
        elevator=false, lampPos={x=5,y=10}, accumulatorPos={x=7,y=9}, energyBuffer="10MJ", energyFlow="2MW", tileCraft="stone-brick",   tile="stone-path", 
        allowedCraftingCategories={"smelting"}, restrictionItemName="stone-furnace", beacon=false, techToUnlock="Skyscrapers_mk1"}
    skyscrapers["skyscraper-1-oil-processing"] = { unique=false, itemCategory="skyscrapers-buildings-mk1", X=10,Y=8, Z=5,  entrancePos={x=0.5,y=4}, exitPos={x=5.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=7,y=7},  stairsDownPos={x=2,y=7},  floorIndicatorPos={x=1,y=8},
        elevator=false, lampPos={x=5,y=10}, accumulatorPos={x=7,y=9}, energyBuffer="10MJ", energyFlow="2MW", tileCraft="stone-brick",   tile="stone-path", 
        allowedCraftingCategories={"oil-processing"}, restrictionItemName="oil-refinery", beacon=false, techToUnlock="Skyscrapers_mk1"}
    skyscrapers["skyscraper-1-chemistry"] =      { unique=false, itemCategory="skyscrapers-buildings-mk1", X=10,Y=8, Z=5,  entrancePos={x=0.5,y=4}, exitPos={x=5.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=7,y=7},  stairsDownPos={x=2,y=7},  floorIndicatorPos={x=1,y=8},
        elevator=false, lampPos={x=5,y=10}, accumulatorPos={x=7,y=9}, energyBuffer="10MJ", energyFlow="2MW", tileCraft="stone-brick",   tile="stone-path", 
        allowedCraftingCategories={"chemistry"}, restrictionItemName="chemical-plant", beacon=false, techToUnlock="Skyscrapers_mk1"}
    skyscrapers["skyscraper-1-centrifuging"] =   { unique=false, itemCategory="skyscrapers-buildings-mk1", X=10,Y=8, Z=5,  entrancePos={x=0.5,y=4}, exitPos={x=5.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=7,y=7},  stairsDownPos={x=2,y=7},  floorIndicatorPos={x=1,y=8},
        elevator=false, lampPos={x=5,y=10}, accumulatorPos={x=7,y=9}, energyBuffer="10MJ", energyFlow="2MW", tileCraft="stone-brick",   tile="stone-path", 
        allowedCraftingCategories={"centrifuging"}, restrictionItemName="centrifuge", beacon=false, techToUnlock="Skyscrapers_mk1"}
    skyscrapers["skyscraper-2-crafting"] =                { unique=false, itemCategory="skyscrapers-buildings-mk2", X=12,Y=10,Z=25, entrancePos={x=0.5,y=5}, exitPos={x=6.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=8,y=9},  stairsDownPos={x=3,y=9},  floorIndicatorPos={x=2,y=10}, 
        elevator=true, lampPos={x=6,y=12}, elevatorPos={x=6,y=9}, elevatorTopSpeed=0.6, accumulatorPos={x=8,y=11}, energyBuffer="50MJ", energyFlow="10MW", tileCraft="concrete",   tile="concrete",
        allowedCraftingCategories={"crafting", "advanced-crafting", "crafting-with-fluid"}, restrictionItemName="assembling-machine-1", beacon=false, techToUnlock="Skyscrapers_mk2"}
    skyscrapers["skyscraper-2-smelting"] =                { unique=false, itemCategory="skyscrapers-buildings-mk2", X=12,Y=10,Z=25, entrancePos={x=0.5,y=5}, exitPos={x=6.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=8,y=9},  stairsDownPos={x=3,y=9},  floorIndicatorPos={x=2,y=10}, 
        elevator=true, lampPos={x=6,y=12}, elevatorPos={x=6,y=9}, elevatorTopSpeed=0.6, accumulatorPos={x=8,y=11}, energyBuffer="50MJ", energyFlow="10MW", tileCraft="concrete",   tile="concrete",
        allowedCraftingCategories={"smelting"}, restrictionItemName="stone-furnace", beacon=false, techToUnlock="Skyscrapers_mk2"}
    skyscrapers["skyscraper-2-oil-processing"] =                { unique=false, itemCategory="skyscrapers-buildings-mk2", X=12,Y=10,Z=25, entrancePos={x=0.5,y=5}, exitPos={x=6.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=8,y=9},  stairsDownPos={x=3,y=9},  floorIndicatorPos={x=2,y=10}, 
        elevator=true, lampPos={x=6,y=12}, elevatorPos={x=6,y=9}, elevatorTopSpeed=0.6, accumulatorPos={x=8,y=11}, energyBuffer="50MJ", energyFlow="10MW", tileCraft="concrete",   tile="concrete",
        allowedCraftingCategories={"oil-processing"}, restrictionItemName="oil-refinery", beacon=false, techToUnlock="Skyscrapers_mk2"}
    skyscrapers["skyscraper-2-chemistry"] =                { unique=false, itemCategory="skyscrapers-buildings-mk2", X=12,Y=10,Z=25, entrancePos={x=0.5,y=5}, exitPos={x=6.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=8,y=9},  stairsDownPos={x=3,y=9},  floorIndicatorPos={x=2,y=10}, 
        elevator=true, lampPos={x=6,y=12}, elevatorPos={x=6,y=9}, elevatorTopSpeed=0.6, accumulatorPos={x=8,y=11}, energyBuffer="50MJ", energyFlow="10MW", tileCraft="concrete",   tile="concrete",
        allowedCraftingCategories={"chemistry"}, restrictionItemName="chemical-plant", beacon=false, techToUnlock="Skyscrapers_mk2"}
    skyscrapers["skyscraper-2-centrifuging"] =                { unique=false, itemCategory="skyscrapers-buildings-mk2", X=12,Y=10,Z=25, entrancePos={x=0.5,y=5}, exitPos={x=6.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=8,y=9},  stairsDownPos={x=3,y=9},  floorIndicatorPos={x=2,y=10}, 
        elevator=true, lampPos={x=6,y=12}, elevatorPos={x=6,y=9}, elevatorTopSpeed=0.6, accumulatorPos={x=8,y=11}, energyBuffer="50MJ", energyFlow="10MW", tileCraft="concrete",   tile="concrete",
        allowedCraftingCategories={"centrifuging"}, restrictionItemName="centrifuge", beacon=false, techToUnlock="Skyscrapers_mk2"}
    skyscrapers["skyscraper-3-crafting"] =                { unique=false, itemCategory="skyscrapers-buildings-mk3", X=14,Y=12,Z=50, entrancePos={x=0.5,y=6}, exitPos={x=7.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=9,y=11}, stairsDownPos={x=4,y=11}, floorIndicatorPos={x=3,y=12}, 
        elevator=true, lampPos={x=7,y=14}, elevatorPos={x=7,y=11}, elevatorTopSpeed=0.8, accumulatorPos={x=9,y=13}, energyBuffer="500MJ", energyFlow="100MW", tileCraft="refined-concrete",  tile="refined-concrete",
        allowedCraftingCategories={"crafting", "advanced-crafting", "crafting-with-fluid"}, restrictionItemName="assembling-machine-1", beacon=true, beaconTemplatePos={x=12,y=13}, beaconModules=2, beaconEfficiency=5, beaconEnergy="24MW", techToUnlock="Skyscrapers_mk3"}
    skyscrapers["skyscraper-3-smelting"] =                { unique=false, itemCategory="skyscrapers-buildings-mk3", X=14,Y=12,Z=50, entrancePos={x=0.5,y=6}, exitPos={x=7.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=9,y=11}, stairsDownPos={x=4,y=11}, floorIndicatorPos={x=3,y=12}, 
        elevator=true, lampPos={x=7,y=14}, elevatorPos={x=7,y=11}, elevatorTopSpeed=0.8, accumulatorPos={x=9,y=13}, energyBuffer="500MJ", energyFlow="100MW", tileCraft="refined-concrete",  tile="refined-concrete",
        allowedCraftingCategories={"smelting"}, restrictionItemName="stone-furnace", beacon=true, beaconTemplatePos={x=12,y=13}, beaconModules=2, beaconEfficiency=5, beaconEnergy="24MW", techToUnlock="Skyscrapers_mk3"}
    skyscrapers["skyscraper-3-oil-processing"] =                { unique=false, itemCategory="skyscrapers-buildings-mk3", X=14,Y=12,Z=50, entrancePos={x=0.5,y=6}, exitPos={x=7.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=9,y=11}, stairsDownPos={x=4,y=11}, floorIndicatorPos={x=3,y=12}, 
        elevator=true, lampPos={x=7,y=14}, elevatorPos={x=7,y=11}, elevatorTopSpeed=0.8, accumulatorPos={x=9,y=13}, energyBuffer="500MJ", energyFlow="100MW", tileCraft="refined-concrete",  tile="refined-concrete",
        allowedCraftingCategories={"oil-processing"}, restrictionItemName="oil-refinery", beacon=true, beaconTemplatePos={x=12,y=13}, beaconModules=2, beaconEfficiency=5, beaconEnergy="24MW", techToUnlock="Skyscrapers_mk3"}
    skyscrapers["skyscraper-3-chemistry"] =                { unique=false, itemCategory="skyscrapers-buildings-mk3", X=14,Y=12,Z=50, entrancePos={x=0.5,y=6}, exitPos={x=7.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=9,y=11}, stairsDownPos={x=4,y=11}, floorIndicatorPos={x=3,y=12}, 
        elevator=true, lampPos={x=7,y=14}, elevatorPos={x=7,y=11}, elevatorTopSpeed=0.8, accumulatorPos={x=9,y=13}, energyBuffer="500MJ", energyFlow="100MW", tileCraft="refined-concrete",  tile="refined-concrete",
        allowedCraftingCategories={"chemistry"}, restrictionItemName="chemical-plant", beacon=true, beaconTemplatePos={x=12,y=13}, beaconModules=2, beaconEfficiency=5, beaconEnergy="24MW", techToUnlock="Skyscrapers_mk3"}
    skyscrapers["skyscraper-3-centrifuging"] =                { unique=false, itemCategory="skyscrapers-buildings-mk3", X=14,Y=12,Z=50, entrancePos={x=0.5,y=6}, exitPos={x=7.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=9,y=11}, stairsDownPos={x=4,y=11}, floorIndicatorPos={x=3,y=12}, 
        elevator=true, lampPos={x=7,y=14}, elevatorPos={x=7,y=11}, elevatorTopSpeed=0.8, accumulatorPos={x=9,y=13}, energyBuffer="500MJ", energyFlow="100MW", tileCraft="refined-concrete",  tile="refined-concrete",
        allowedCraftingCategories={"centrifuging"}, restrictionItemName="centrifuge", beacon=true, beaconTemplatePos={x=12,y=13}, beaconModules=2, beaconEfficiency=5, beaconEnergy="24MW", techToUnlock="Skyscrapers_mk3"}
    --mk4s, unique(only one instance at a time??, with cultural references
    --scale derived from https://vignette.wikia.nocookie.net/finalfantasy/images/1/11/Headquarters_f64.png/revision/latest?cb=20110517030706
    skyscrapers["skyscraper-shinra-tower"] =     { unique=true, uniqueName="Shinra Headquarters", uniqueDescription="The Headquarters of the Shinra Electric Power Company, also known as Shinra Inc.", X=38,Y=26,Z=70,  entrancePos={x=0.5,y=13}, exitPos={x=19.5,y=0}, numFrames=1, animationSpeed=0.001,
        stairsUpPos={x=21,y=25}, stairsDownPos={x=16,y=25}, floorIndicatorPos={x=15,y=26}, 
        elevator=true, lampPos={x=19,y=28}, elevatorPos={x=19,y=25}, elevatorTopSpeed=1.0, accumulatorPos={x=21,y=27}, energyBuffer="5GJ", energyFlow="1GW", tileCraft="refined-concrete",  tile="refined-concrete",
        beacon=true, beaconTemplatePos={x=24,y=27}, beaconModules=3, beaconEfficiency=6, beaconEnergy="50MW", predecessorTech="Skyscrapers_mk3", 
        techingredients ={{"science-pack-1", 1},{"science-pack-2", 1},{"science-pack-3", 1},{"military-science-pack", 1},{"production-science-pack", 1},{"high-tech-science-pack", 1}}, techingredientsCount=1000,
        techName="Shinra Headquarters", techDescription="Research how to construct the Headquarters of the Shinra Electric Power Company, also known as Shinra Inc."}
    return skyscrapers
end

function getHighestSkyscraper()
    local maxZ = 0
    for _,val in pairs(getSkyscraperDefinitions()) do
        maxZ = math.max(maxZ,val.Z)
    end
    return maxZ
end

function getBiggestSkyscraperX()
    local maxX = 0
    for _,val in pairs(getSkyscraperDefinitions()) do
        maxX = math.max(maxX,val.X)
    end
    return maxX
end

function getBiggestSkyscraperY()
    local maxY = 0
    for _,val in pairs(getSkyscraperDefinitions()) do
        maxY = math.max(maxY,val.Y)
    end
    return maxY
end

local premadeDefinitions = {}
local listOfDefinitions = {
    "skyscraper_premade_gears_mk1",
    "skyscraper_premade_gears_mk2",
    "skyscraper_premade_smelting_mk1",
    "skyscraper_premade_smelting_mk2",
}
for _,e in pairs(listOfDefinitions) do
    premadeDefinitions[e] = require("premade/".. e)
end

function getPremadeSkyscraperDefinitions()
    return premadeDefinitions
end
